hdu--1072--Nightmare(bfs回溯)

Nightmare

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 11273    Accepted Submission(s): 5493

Problem Description

Ignatius had a nightmare last night. He found himself in a labyrinth with a time bomb on him. The labyrinth has an exit, Ignatius should get out of the labyrinth before the bomb explodes. The initial exploding time of the bomb is set to 6 minutes. To prevent the bomb from exploding by shake, Ignatius had to move slowly, that is to move from one area to the nearest area(that is, if Ignatius stands on (x,y) now, he could only on (x+1,y), (x-1,y), (x,y+1), or (x,y-1) in the next minute) takes him 1 minute. Some area in the labyrinth contains a Bomb-Reset-Equipment. They could reset the exploding time to 6 minutes.

Given the layout of the labyrinth and Ignatius‘ start position, please tell Ignatius whether he could get out of the labyrinth, if he could, output the minimum time that he has to use to find the exit of the labyrinth, else output -1.

Here are some rules:
1. We can assume the labyrinth is a 2 array.
2. Each minute, Ignatius could only get to one of the nearest area, and he should not walk out of the border, of course he could not walk on a wall, too.
3. If Ignatius get to the exit when the exploding time turns to 0, he can‘t get out of the labyrinth.
4. If Ignatius get to the area which contains Bomb-Rest-Equipment when the exploding time turns to 0, he can‘t use the equipment to reset the bomb.
5. A Bomb-Reset-Equipment can be used as many times as you wish, if it is needed, Ignatius can get to any areas in the labyrinth as many times as you wish.
6. The time to reset the exploding time can be ignore, in other words, if Ignatius get to an area which contain Bomb-Rest-Equipment, and the exploding time is larger than 0, the exploding time would be reset to 6.

Input

The input contains several test cases. The first line of the input is a single integer T which is the number of test cases. T test cases follow.
Each test case starts with two integers N and M(1<=N,Mm=8) which indicate the size of the labyrinth. Then N lines follow, each line contains M integers. The array indicates the layout of the labyrinth.
There are five integers which indicate the different type of area in the labyrinth:
0: The area is a wall, Ignatius should not walk on it.
1: The area contains nothing, Ignatius can walk on it.
2: Ignatius‘ start position, Ignatius starts his escape from this position.
3: The exit of the labyrinth, Ignatius‘ target position.
4: The area contains a Bomb-Reset-Equipment, Ignatius can delay the exploding time by walking to these areas.

Output

For each test case, if Ignatius can get out of the labyrinth, you should output the minimum time he needs, else you should just output -1.

Sample Input

3

3 3

2 1 1

1 1 0

1 1 3

4 8

2 1 1 0 1 1 1 0

1 0 4 1 1 0 4 1

1 0 0 0 0 0 0 1

1 1 1 4 1 1 1 3

5 8

1 2 1 1 1 1 1 4

1 0 0 0 1 0 0 1

1 4 1 0 1 1 0 1

1 0 0 0 0 3 0 1

1 1 4 1 1 1 1 1

Sample Output

4

-1

13

 1 /*
 2     Name: hdu--1072--Nightmare
 3     Copyright: ?2017 日天大帝
 4     Author: 日天大帝
 5     Date: 22/04/17 14:53
 6     Description: bfs有条件回溯,走过的路还得判断能不能走, vis[a.x][a.y] >= temp.time
 7                 判断,如果走回去,原来点的时间增加了,那么就回溯
 8 */
 9 #include<iostream>
10 #include<cstring>
11 #include<queue>
12 using namespace std;
13 struct node{
14     int x,y,time,steps;
15     bool operator<(const node &a)const{
16         return steps>a.steps;
17     }
18 };
19 int map[10][10];
20 int vis[10][10];
21 int dir[4][2] = {0,1,0,-1,-1,0,1,0};
22 int m,n;
23 node s,e;
24 void bfs(){
25     priority_queue<node> q;
26     s.time = 6;
27     s.steps = 0;
28     q.push(s);
29     while(!q.empty()){
30         node a,temp = q.top();q.pop();
31         if(temp.x == e.x && temp.y == e.y){
32             cout<<temp.steps<<endl;return ;
33         }
34         for(int i=0; i<4; ++i){
35             a = temp;
36             a.x += dir[i][0];
37             a.y += dir[i][1];
38             a.time--;
39             a.steps ++;
40             if(a.time<=0||a.x<0||a.y<0||a.x>=n||a.y>=m||map[a.x][a.y] == 0|| vis[a.x][a.y] >= temp.time)continue;
41             if(map[a.x][a.y] == 4)a.time = 6;
42             vis[a.x][a.y] = a.time;
43             q.push(a);
44         }
45     }
46     cout<<-1<<endl;
47 }
48 int main(){
49     ios::sync_with_stdio(false);
50
51     int t;cin>>t;
52     while(t--){
53         memset(vis,0,sizeof(vis));
54         memset(map,0,sizeof(map));
55         cin>>n>>m;
56         for(int i=0; i<n; ++i){
57             for(int j=0; j<m; ++j){
58                 cin>>map[i][j];
59                 if(map[i][j] == 2){
60                     s.x = i;s.y = j;
61                 }
62                 if(map[i][j] == 3){
63                     e.x = i;e.y = j;
64                 }
65             }
66         }
67         vis[s.x][s.y] = 6;
68         bfs();
69     }
70     return 0;
71 }
时间: 2024-10-27 07:50:21

hdu--1072--Nightmare(bfs回溯)的相关文章

hdu 1072 Nightmare BFS,第一次刷BFS的题,感好牛逼的。。。

Nightmare Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 7758    Accepted Submission(s): 3723 Problem Description Ignatius had a nightmare last night. He found himself in a labyrinth with a ti

HDU 1072 Nightmare BFS

其实就是多加了一个引爆时间的限制条件,反正n,m给的很小,直接记录3维状态,之后就很随意了. #include <cstdio> #include <cstring> #include <iostream> #include <map> #include <set> #include <vector> #include <string> #include <queue> #include <deque&g

HDU 1072 Nightmare (BFS)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=1072 题目大意: 走迷宫,初始剩余时间为6min,每步1min:到reset区是若剩余时间大于0,则可以重置.到终点3区,若时间大于0,则成功逃脱.(可以走回路) 0:wall 1:可以走 2:起点 3:终点 4:剩余时间重置为6 源代码: #include<iostream> #include<cstring> #include<cstdio> #include<q

HDU 1072 Nightmare(BFS)

Nightmare Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 9120    Accepted Submission(s): 4389 Problem Description Ignatius had a nightmare last night. He found himself in a labyrinth with a ti

HDU 1072 Nightmare( 身上带有定时炸弹的他能否在炸弹爆炸之前离开—— BFS+DP思想)

Nightmare Time Limit:1000MS     Memory Limit:32768KB     64bit IO Format:%I64d & %I64u Description Ignatius had a nightmare last night. He found himself in a labyrinth with a time bomb on him. The labyrinth has an exit, Ignatius should get out of the

hdu 1072 Nightmare

还是bfs,主要考虑剪枝,数组标记走过时炸弹剩余的时间,以及炸弹延时后将4变成1 #include<stdio.h> #include<string.h> #include<algorithm> #include<queue> using namespace std; struct node { int x,y,s,w; }t,t0; int n,m,g[10][10],vis[10][10]; int dx[]={0,0,1,-1}; int dy[]={

HDU 1072 (不一样的入队条件) Nightmare

之前的BFS都是需要一个标记数组,但这个题不一样,因为可能一个格子不止走一次. 那么我们就要寻找新的入队条件:left比上次经过的时候大才入队(left表示上次经过该点时剩余的时间). 为什么呢?我们重复走过一个点只有一个可能,那就是为了去取那个,所以如果取完后再回头经过这个点的时候剩余时间变多了,我们的目的就达到了. left数组初值为0 优化: 重置时间的装置最多取一次就够了,所以可以再开一个标记数组vis记录装置是否用过. 1 //#define LOCAL 2 #include <cst

HDU 1072 bfs

Nightmare Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)Total Submission(s): 7083    Accepted Submission(s): 3409 Problem Description Ignatius had a nightmare last night. He found himself in a labyrinth with a tim

HDU 3085 Nightmare Ⅱ (双向广搜)

题意:有M,G两人和鬼魂(Z)在n*m的方格内,M每秒走3步,G每秒走一步,鬼魂每秒走2步,问是否能 不遇到鬼魂下两人相遇,鬼魂可以穿墙(X),人不可以.初始鬼魂有2个. #include<stdio.h> #include<string.h> #include<string> #include<queue> #include<map> #include<iostream> #include<algorithm> #def

HDUJ 1072 Nightmare 搜索

Nightmare Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 6992    Accepted Submission(s): 3354 Problem Description Ignatius had a nightmare last night. He found himself in a labyrinth with a ti